# -*- coding: utf-8 -*-
require 'socket'
require 'webrick'

def op(s, *a)
  s.print(a*"\t"+"\n")
  s.flush
end

DATA = [
        ['パーティクルで', 'プレゼン', 'はまじ'],
        ['背景', 'pbg', '俺 sandbox'],
        ['とくちょう1', 'むだに', '派手'],
        ['とくちょう2', 'やたら', '読みにくい'],
        ['とくちょう3', '文字数', '少ない'],
        ['とくちょう4', 'ページ遷移', 'おそい'],
        ['とくちょう5', 'ゆれる', '文字'],
        ['とくちょう6', '重力'],
        ['じっそう1', 'D言語', 'pbgベース'],
        ['じっそう2', 'SDL', 'OpenGL'],
        ['じっそう3', 'SDL_ttf', 'SDL_pad'],
        ['じっそう4', 'サバクラ', '制御はRuby'],
        ['じっそう5', 'std.socket', 'std.thread?'],
        ['こんなことも1', '普通の', '文字'],
        ['こんなことも2', 'カメラ', 'ワ〜ク'],
        ['こんなことも3', 'ピクセル', 'シェーダ'],
        ['こんなことも4', 'リアル', 'カメラ'],
        ['こんなことも5', '音量', 'チェック'],
        ['おわり', 'http://', 'x.shinh.org'],
       ]

#s = TCPSocket.open('192.168.123.1', 2525)
$sock = s = TCPSocket.open('localhost', 2525)

class PbgServlet < WEBrick::HTTPServlet::AbstractServlet
  def do_GET(req, res)
    l1 = req.query['l1']
    l2 = req.query['l2']
    l3 = req.query['l3']
    if l1 && l2 && l3 && l1[0] && l2[0] && l3[0]
      op($sock, 'release')
      op($sock, 'text', l1, 100, 100 + 0 * 90)
      op($sock, 'text', l2, 100, 100 + 1 * 90)
      op($sock, 'text', l3, 100, 100 + 2 * 90)
    end
      s = %Q(
<form method="GET">
<ol>
<li><input name="l1">
<li><input name="l2">
<li><input name="l3">
</ol>
<input type="submit">
</form>
)
      res.body = s
    res['Content-Type'] = 'text/html; charset=UTF8'
  end
end

th = Thread.new do
  server = WEBrick::HTTPServer.new({ :BindAddress => '0.0.0.0',
                                     :Port => 10080})
  server.mount('/', PbgServlet)
  server.start
end

pn = 0
#pn = DATA.size-1
prevpn = nil

while true
  if prevpn != pn
    op(s, 'release')
    sleep 1
    DATA[pn].each_with_index do |v, i|
      if v
        puts v
        op(s, 'text', v, 100, 100 + i * 90)
        sleep 1
      end
    end
    p pn
    prevpn = pn
  end

  op(s, 'poll')
  ev = s.gets.chomp
  p ev
  if ev == 'RIGHT'
    if pn+1 < DATA.size
      pn += 1
    end
  elsif ev == 'LEFT'
    if pn > 0
      pn -= 1
    end
  end
end

s.close
th.kill
