module gleeTypes;

///////////////////////////////////
//
// GLeeTypes.h ;
// OpenGL Easy Extension library        
// Version : 3.0;
//
// Copyright (c)2004  Ben Woodhouse  All rights reserved.;
//
// Redistribution and use _in source and binary forms, with or without
// modification, are permitted provided that the following conditions are 
// met:
// 1. Redistributions of source code must retain the above copyright
// notice, this list of conditions and the following disclaimer as
// the first lines of this file unmodified.
// 2. Redistributions _in binary form must reproduce the above copyright
// notice, this list of conditions and the following disclaimer _in the
// documentation and/or other materials provided with the distribution.
//
// THIS SOFTWARE IS PROVIDED BY BEN WOODHOUSE ``AS IS'' AND ANY EXPRESS OR
// IMPLIED WARRANTIES, INCLUDING, BUT NOT LIMITED TO, THE IMPLIED WARRANTIES
// OF MERCHANTABILITY AND FITNESS FOR A PARTICULAR PURPOSE ARE DISCLAIMED.
// IN NO EVENT SHALL BEN WOODHOUSE BE LIABLE FOR ANY DIRECT, INDIRECT,
// INCIDENTAL, SPECIAL, EXEMPLARY, OR CONSEQUENTIAL DAMAGES (INCLUDING, BUT
// NOT LIMITED TO, PROCUREMENT OF SUBSTITUTE GOODS OR SERVICES LOSS OF USE,
// DATA, OR PROFITS OR BUSINESS INTERRUPTION) HOWEVER CAUSED AND ON ANY
// THEORY OF LIABILITY, WHETHER IN CONTRACT, STRICT LIABILITY, OR TORT
// (INCLUDING NEGLIGENCE OR OTHERWISE) ARISING IN ANY WAY OUT OF THE USE OF
// THIS SOFTWARE, EVEN IF ADVISED OF THE POSSIBILITY OF SUCH DAMAGE.
//
// This licence includes and incorporates the SGI FREE SOFTWARE LICENSE B 
// (Version 1.1 [02/22/2000]) full details of which can be found at
// http://oss.sgi.com/projects/FreeB
//
// For the avoidance of doubt, this work falls within the definition of a 
// 'Larger Work' within that licence, since it incorporates parts of SGI's
// glExt.h, wglExt.h and glxExt.h header files, which form part of SGI's
// OpenGL Sample Implementation. 
// Web: http://elf-stone.com
//
// [This file was automatically generated by GLeeGen]
//
// Then it was ported manually by Joel Anderson to D (1\21\2004)
//
// And then it was modified by Mike Parker and included in the Derelict project 
// on May 25, 2004
///////////////////////////////////

private 
{ 
    version (Win32) {
        import std.c.windows.windows;
    }
	// import glConstants;
	import gleeTypes;
}

extern (C)
{
	
	alias int BOOLEAN;
	alias int INT32;
	alias long INT64;
		
	//Additional types needed for extensions
	extern (Windows) int errno;
	alias int ptrdiff_t;
	alias uint size_t;
	alias ushort wchar_t;
	alias ptrdiff_t GLintptr;
	alias ptrdiff_t GLsizeiptr;
	// GL_NV_half_float;
	alias ushort GLhalfNV;
	
	// GL_ARB_vertex_buffer_object;
	alias ptrdiff_t GLintptrARB;
	alias ptrdiff_t GLsizeiptrARB;
	
	// GL_ARB_shader_objects;
	alias int GLhandleARB;
	alias char GLcharARB;
	
	//platform specific :;
	
	version(Windows)
	{
	//#ifndef WGL_ARB_pbuffer;
	alias HANDLE HPBUFFERARB ;
	//#ifndef WGL_EXT_pbuffer;
	alias HANDLE HPBUFFEREXT ;
	} // version(Windows)
}
